// DaveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Dave.h"
#include "DaveDlg.h"
#include ".\davedlg.h"
#include "Windows.h"
#include "Child1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

int Count = 0;

// CDaveDlg dialog
static int ClientWidth = 786;
static int ClientHeight = 256;
static int NumberOfBytesPerRow = 0;
static HBITMAP BitmapObjectHandle = NULL;
static BYTE* ImageData = NULL;
static HDC CompatibleDeviceContextHandle = NULL;
static HDC WindowDeviceContextHandle;
static CDC* pDC;

struct MyBITMAPINFO
{
BITMAPINFOHEADER bmiHeader;
RGBQUAD bmiColors[256];
};

RECT ClientRectangle;
MyBITMAPINFO Bitmap;
int Index, x, y;

DWORD CALLBACK UpdateWndThread(LPVOID pVoid)
{
	HWND hwnd = (HWND)pVoid;
	while(1)
	{
		static int add = 0;
		add += 1;
		for (int y = 0; y < ClientWidth; y++)
		{
			int val = (y + add) % 256;
			for (int x = 0; x < ClientHeight; x++)
			{
				ImageData[x * NumberOfBytesPerRow + y] = val;
			}
		} 

		InvalidateRect(hwnd, NULL, FALSE);
		Sleep(10);
	}
	return 0;
}

CDaveDlg::CDaveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDaveDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDaveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDaveDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP

	
	ON_BN_CLICKED(IDChildOpen, OnBnClickedChildopen)
END_MESSAGE_MAP()

BOOL CDaveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	
	//Cretae Bitmap Object
	pDC=GetDC();
	CompatibleDeviceContextHandle = CreateCompatibleDC(*pDC);
	ReleaseDC(pDC);

	NumberOfBytesPerRow = (ClientWidth + 3) & 0xFFFFFFFC;

	Bitmap.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	Bitmap.bmiHeader.biWidth = ClientWidth;
	Bitmap.bmiHeader.biHeight = -ClientHeight;
	Bitmap.bmiHeader.biPlanes = 1;
	Bitmap.bmiHeader.biBitCount = 8;
	Bitmap.bmiHeader.biCompression = BI_RGB;
	Bitmap.bmiHeader.biSizeImage = NumberOfBytesPerRow * ClientHeight;
	Bitmap.bmiHeader.biXPelsPerMeter = 0;
	Bitmap.bmiHeader.biYPelsPerMeter = 0;
	Bitmap.bmiHeader.biClrUsed = 256;
	Bitmap.bmiHeader.biClrImportant = 256;
	for (Index = 0; Index < 256; Index = Index + 1)
	{
		Bitmap.bmiColors[Index].rgbBlue = Index;
		Bitmap.bmiColors[Index].rgbGreen = Index;
		Bitmap.bmiColors[Index].rgbRed = Index;
		Bitmap.bmiColors[Index].rgbReserved = 0;
	}	

	BitmapObjectHandle = CreateDIBSection(CompatibleDeviceContextHandle, (BITMAPINFO*)(&Bitmap), DIB_RGB_COLORS, (void**)(&ImageData), NULL, 0);
	SelectObject(CompatibleDeviceContextHandle, BitmapObjectHandle);

	DWORD threadId;
	CloseHandle(CreateThread(NULL, 0, UpdateWndThread, *this, 0, &threadId));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDaveDlg::OnPaint() 
{
	CPaintDC dc(this);

	char Str[100] = "Refresh Rate:";
		Count++;
		itoa(Count,Str,10);			
		CRect rc;
		dc.SetTextColor(RGB(255, 0, 0)); 
		dc.TextOut(500,350,"Refresh Count : ",16);
		dc.TextOut(600,350,Str,strlen(Str));


	BitBlt(dc, 0, 0, ClientWidth, ClientHeight, CompatibleDeviceContextHandle, 0, 0, SRCCOPY);
	
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDaveDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CDaveDlg::OnBnClickedChildopen()
{	
 	CChild1 cobj(this);
	cobj.DoModal();
}
